<?php
/*
Plugin Name: Comment Link Target Blanker (CLTB)
Plugin URI: http://wp-plugins.net/plugin/comment-target-blank/
Description: This plugin will add <code>target="_blank"</code> to URLs in comments so they open in new windows.  It is simply a bug-fixed clone of the most important feature of the <a href="http://www.techwench.com/05-2005/plugin-blank-target-comments/" target="_blank">Blank Target Comments plugin</a> but which, unlike BTC, is compatible with (and detects) the <a href="http://minglewithingle.com/index.php?s=link+truncator" target="_blank">Link Truncator plugin</a>, and generates valid markup under WP2.  Intended especially to be run in conjunction with the <a href="http://wp-plugins.net/plugin/posts-autolink/">AutoLink &amp; More in Posts &amp; Excerpts plugin</a>.  Unlike BTC, it does not mess with comment author URL targets/nofollows (features of BTC that I don't find useful).  Only tested on WP 2.0.  
Version: 1.0b
Author: Stanton McCandlish (nominally)
Author URI: http://www.McCandlishConsulting.com/
*/

/* Installation: Read the readme file! */

/* ** THIS FILE *MUST* LOAD *AFTER* LT, if LT is installed!  Thus the filename
      of this script, which pushes it down toward bottom of the plugin list. */

/* Creative Commons Section 

Copyright 2006 Stanton McCandlish; some rights reserved. 
  
This work is licensed under the Creative Commons Attribution-ShareAlike License. To view a copy of this license, visit http://creativecommons.org/licenses/by-sa/2.5/ or send a letter to Creative Commons, 559 Nathan Abbott Way, Stanford, California 94305, USA. */


  if (function_exists('wp_rel_nofollow_blanktarget')) {
    remove_filter('comment_text', 'wp_rel_nofollow_blanktarget');
    add_filter ('comment_text', 'wp_rel_nofollow');
  }
  if (function_exists('get_comment_author_link_blanktarget')) {
    remove_filter ('get_comment_author_link', 'get_comment_author_link_blanktarget');
    add_filter ('get_comment_author','get_comment_author_link');
  }
  if (function_exists('make_clickable_blanktarget')) {
    remove_filter ('comment_text', 'make_clickable_blanktarget');
    add_filter ('comment_text', 'make_clickable');

  }
  /* The point of that is to detect if BTC is also accidentally installed too, 
     and undo what it does back to a clean slate. */
  
  /* Now reroute LT's behavior through a new function that integrates it
     with the code we've ripped from BTC; if LT not installed we still want
     the BTC-type behavior to get processed by our new function anyway. */
  if (function_exists('make_more_clickable')) {
    remove_filter ('comment_text', 'make_more_clickable');
    add_filter ('comment_text','make_more_clickable2');
  } elseif (function_exists('make_clickable')) { 
    remove_filter ('comment_text', 'make_clickable');
    add_filter ('comment_text','make_more_clickable2');
  }

function make_more_clickable2($ret)
{
    if (function_exists('make_more_clickable')) {
      $ret = make_more_clickable($ret);        # If LT is installed, use it...    
    } elseif (function_exists('make_clickable')) { 
      $ret = make_clickable($ret);       # else use the default; either way...
    }
    $ret = wp_rel_nofollow_blanktarget2($ret);    # use the func. below on it.
	return $ret;
}

/* [end Creative Commons Section] */


/*
I would have just combined the compatible features of both BTC and LT plugins, but their licenses are also mutually incompatible, so I've chosen to just strip BTC down to what it needs.  Every line of actual code below this point was written by "Tech Wench", author of BTC.  If the authors of BTC and LT want to work out compatibility between ALL of their features, I'll happily remove this kluge from distribution. 

/* GPL Section */

/*    License Information:
    ==============================================================
    
    Copyright (C) 2005 - Priss's House of Crap - www.prissed.com
    
    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.
    
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
    
    Full text found here:  http://www.gnu.org/licenses/gpl.html
*/

remove_filter ('comment_text', 'wp_rel_nofollow');
#add_filter ('comment_text', 'wp_rel_nofollow_blanktarget2');

function wp_rel_nofollow_blanktarget2( $text ) {
	$text = preg_replace('|<a (.+?)>|i', '<a $1 target="_blank">', $text);
	return $text;
}

/* [end GPL Section] */

/* Note: I removed the rel="nofollow" from the above function; WP2 already
   handles this automatically. It was causing invalid duplicate attributes
   & values in WP2.0.  If you use WP1.x, you can uncomment the add_filter
   line above. And I renamed wp_rel_nofollow_blanktarget to
   wp_rel_nofollow_blanktarget2 just in case someone daft tries to run
   this plugin and BTC at the same time! - S.McC. */


?>